// dies ist ein Template
// Administrator ist Platzhalter; wird zur Laufzeit ersetzt durch echten Benutzer-Namen.
// fuer jeden Benutzer wird ein .js File geschrieben, wenn auch das .json File geschrieben wird
// eigentlich koennte man die Daten des .json Files auch hier direkt mit rein schreiben.
// sinnvoll wäre, beim User-Login seine Files neu zu generieren

var elmResults, elmSearch, ajaxRequest;

$(document).ready(function() {
    var currentSelection = 0;
    elmResults = $("#results");
    elmSearch = $("#search");
    $('.Buttons').css('z-index','10');
    $("#moreModules").click(function() {
        var position = $("#moreModules").position();
        $("#more").toggle().css("left", position.left + 1);
    });

    var position = elmSearch.position();
    if(position)
        elmResults.css("left", position.left);
    $('#TableView').dragtable({dragHandle: '.drag-handle'});

    $(".PBActionLinkSmall").materialripple();
    $(".PBActionLinkModul").materialripple();
    $(".PBActionLinkSmallNoBlock").materialripple();
    // Items-Eigenschaft funktioniert hier nicht, man könnte statt document aber folgenden Selektor verwenden
    // $("[title!='']:not(.noToolTip)").tooltip({
    $(document).tooltip({
        show: { delay: 300 }
    });
    $(document).tooltip().off("focusin focusout");

    $(document).keydown(function(e) {
        if (document.activeElement.id == "search" || elmSearch.hasClass("active") == true) {
            switch (e.keyCode) {
                //"up"
                case 38:
                    navigate("up");
                    break;
                    //"down"
                case 40:
                    navigate("down");
                    break;
                    //"enter"
                case 13:
                    var selectedModule = elmResults.find("ul li a.search_hover:first");
                    if (selectedModule) {
                        selectedModule.click();
                    }
                    break;
            }

            if ($(".CodeMirror").length == 0) {
                if (e.keyCode == 40) {
                    elmSearch.blur();
                    return false;
                }
                // ESC
                if (e.keyCode == 27) {
                    elmResults.hide();
                    elmSearch.blur();
                    return false;
                }
                //back arrow or backspace press
                if (e.keyCode == 37 || e.keyCode == 8) {
                    if (!document.activeElement.name) {
                        elmSearch.focus();
                    }
                }
            }
        }
    });

    elmSearch.keydown(function(e) {
        if (e.keyCode == 13) { // enter
            e.preventDefault();
            var itm = elmResults.find("ul li:first a");
            if (itm) {
                itm.click();
                return false;
            }
        }
        return true;
    });

    elmSearch.keyup(function() {
        var searchField = elmSearch.val();
        var regex = new RegExp(searchField, "i");
        var output = "<ul>";
        var i = 0;
        if (searchField.length > 1) {
            if (ajaxRequest !== undefined)
                ajaxRequest.abort();

            ajaxRequest = $.ajax({
                type: "GET",
                url: "/Resources/UserModuls/Administrator.json",
                async: true,
                keystring: searchField,
                success: function(data) {
                    var items = $(data).get();
                    items.sort(function(a,b){
                        if (a.guiName > b.guiName)
                            return 1;
                        else if(a.guiName < b.guiName)
                            return -1;
                        else return 0
                    });

                    $.each(items, function(key, val) {
                        if ((val.name.search(regex) != -1) || (val.guiName.search(regex) != -1)) {
                            output += '<li><a title="' + val.guiName + '" href="#" onclick="{document.forms[0].clickedRowNumber.value=\'' + val.name + '\'; sbm(\'action_gotoModuleName\');}">' + val.guiName + '</a></li>';
                            i++;
                        }
                        return (i !== 20);
                    });
                    output += "</ul>"
                    elmResults.html(output);
                    if (output) {
                        elmResults.show();
                    }
                    ajaxRequest = undefined;
                },
                error: function(data) {
                    if (data.status !== 0) {
                        console.log("Fehler beim Laden des Usermoduls: " + data.statusText);
                        ajaxRequest = undefined;
                    }
                },
            });
        } else {
            elmResults.hide();
        }
    });

    $("body").click(function() {
        elmResults.hide();
        currentSelection = 0;
    });

    elmSearch.click(function() {
        $(this).val("");
        $("#search").addClass('active');
    });
});

function navigate(direction) {
    if (elmResults.find("ul li .search_hover").size() == 0) {
        currentSelection = -1;
    }

    if (direction == "up") {
        if (currentSelection == 0)
            elmSearch.focus();
        else if (currentSelection != -1)
            currentSelection--;
    } else if (direction == "down") {
        if (currentSelection != elmResults.find("ul li").size() - 1) {
            currentSelection++;
        }
    }

    setSelected(currentSelection);
}

function setSelected(menuitem) {
    var selMenuItem = elmResults.find("ul li a").eq(menuitem);
    var title = selMenuItem.attr("title");
    elmSearch.val(title);
    elmResults.find("ul li a").removeClass("search_hover");
    selMenuItem.addClass("search_hover");
}
